#include <stdio.h>
#include <stdlib.h>
#include <math.h>

const float x1 = 0;
const float x2 = 10;

double rurka(double x, double y) {
	return (sin (x) * cos (x) - y * cos (x));
}

int main () {
	int steps;
	double h;
  	double eulerN = 0;
  	double rungeN = 0;
  	double eulerN1;
  	double rungeN1 = 0;
  	double x = x1;
  	double k1, k2, k3, k4;
  	int i;
	FILE*fe = fopen("out.e", "w");
	FILE*frk = fopen("out.rk", "w");
	
	printf("Podaj ilosc krokow: ");
	scanf("%d", &steps);
	
	h = (x2 - x1) / steps;
	
  	for (i = 1; i <= steps; i++) {
		eulerN1 = eulerN + h * rurka(x, eulerN);

		k1 = rurka(x, rungeN);
    		k2 = rurka(x + 0.5 *h, rungeN + 0.5 * h * k1);
    		k3 = rurka(x + 0.5 *h, rungeN + 0.5 * h * k2);
		k4 = rurka(x + h, rungeN + h*k3);
    		rungeN1 = rungeN + h/6 * ( k1 + 2 * k2 + 2 * k3 + k4);

		fprintf(fe, "%f %f\n", x, eulerN1);
		fprintf(frk, "%f %f\n", x, rungeN1);
		x += h;
    		eulerN = eulerN1;
    		rungeN = rungeN1;
  	}
	fclose(fe);
	fclose(frk);
  	return EXIT_SUCCESS;
}
