#include<stdio.h>
#include<stdlib.h>
#include<math.h>

#define MAX 1000

double ffunction(int F1orF2, double t, double x, double y) {
	if( F1orF2 == 0 ) {
        	return ( -1.0 * x + t );
        } else {
            	return ( -1.0 * x );
        }
}

int main() {
    	int K, J;
    	int N;
    	double A = 0, B = 0.5 * M_PI;
    	double H;
    	double T[MAX+1]; 
    	double K1, K2, K3, K4;
    	double R1, R2, R3, R4;
    	int F1orF2 = 0;
    	double Xj, Yj, Tj;
    	double X[MAX], Y[MAX];
    	double X1[MAX], X2[MAX];
    	double Alpha = 1, Beta =  0.5 * M_PI - 1;
	FILE* plik;

	printf("Podaj ilosc krokow: ");
	scanf("%d", &N);
	
    	H = (B - A) / N;

    	for ( K = 0; K <= 1; K++) {
	        F1orF2 = K;

        	if( K == 0 ) {
         		X[0]  = Alpha;
         		X1[0] = X[0];
         		Y[0]  = 0.0;
        	} else {
         		X[0]  = 0.0;
         		X2[0] = X[0];
         		Y[0]  = 1.0;
        	}

        	T[0] = A;

        	for( J = 0; J <= N - 2; J++) {
            		Tj = T[J];
            		Xj = X[J];
            		Yj = Y[J];
            		K1 = H * Yj;
            		R1 = H * ffunction(F1orF2, Tj, Xj, Yj);
            		K2 = H * ( Yj + R1 / 2.0);
            		R2 = H * ffunction(F1orF2, Tj + H/2.0, Xj + K1/2.0, Yj + R1/2.0);
            		K3 = H * ( Yj + R2 / 2.0);
            		R3 = H * ffunction(F1orF2, Tj + H/2.0, Xj + K2/2.0, Yj + R2/2.0);
            		K4 = H * (Yj + R3);
            		R4 = H * ffunction(F1orF2, Tj + H , Xj + K3, Yj + R3);
            		X[J+1] = Xj + (K1 + 2.0*K2 + 2.0*K3 + K4) / 6.0;
            		Y[J+1] = Yj + (R1 + 2.0*R2 + 2.0*R3 + R4) / 6.0;
            		T[J+1] = A + H * (J+1);

            		if(K == 0)
				X1[J+1] = X[J+1]; 
            		if(K == 1)
				X2[J+1] = X[J+1]; 
        	}
	}

    	for (J = 0; J < N; J++) 
		X[J] = X1[J] + (Beta - X1[N-1]) * X2[J] / X2[N-1];
    
    	plik = fopen("f.out","w");
    	for ( J = 0; J < N; J++) {
       		fprintf(plik,"%f %f\n", A+(double)J/(N-1)*B, X[J]);
    	} 
    	fclose(plik);
}
